/*----------------------------------------------------------------------------

  Light SSTP Client
  Copyright(C) 2001 Koumei Hashimoto, all rights reserved.

  dsstp.cpp

----------------------------------------------------------------------------*/
#include "header.h"

/*----------------------------------------------------------------------------
	[J`
----------------------------------------------------------------------------*/
#define MY_DIRECTSSTP_PORT	9801
#define MY_EXIST_FILEMAP	"Sakura"

/*----------------------------------------------------------------------------
	֐錾
----------------------------------------------------------------------------*/
BOOL CheckSakuraMutex();

/*----------------------------------------------------------------------------
	lstrchr()
	}`oCgstrchr
----------------------------------------------------------------------------*/
LPSTR lstrchr(LPCSTR sz, CHAR ch)
{
	return (LPSTR)_mbschr((LPBYTE)sz, (UINT)ch);
}

/*----------------------------------------------------------------------------
	CheckSakuraFileMapping()
	t@C}bsOIuWFNg̑݊mF
----------------------------------------------------------------------------*/
BOOL CheckSakuraFileMapping(HWND hParentWnd, vector<HWND>& vec)
{
	HANDLE hFileMap;
	LPVOID lpBasePtr;
	LPSTR lpBuffer;
	LPSTR lpType1;
	LPSTR lpType2;
	CHAR szTemp[200];
	DWORD dwSize;
	HWND hWnd = NULL;
	BOOL bRet;

	vec.clear();

	// t@C}bvJ
	hFileMap = OpenFileMapping(FILE_MAP_READ, FALSE, MY_EXIST_FILEMAP);
	if(hFileMap == NULL) 
	{
		// ݂Ȃ
		MessageBox(hParentWnd, "t@C}bsOIuWFNgJ܂B", "TestSSTP", MB_ICONSTOP);
		return FALSE;
	}

	// x[XAhX擾
	lpBasePtr = (LPVOID)MapViewOfFile(hFileMap, FILE_MAP_READ, 0, 0, 0);
	if(lpBasePtr == NULL)
	{
		// s
		MessageBox(hParentWnd, "t@C}bsOIuWFNgł܂B", "TestSSTP", MB_ICONSTOP);
		CloseHandle(hFileMap);
		return FALSE;
	}
	lpBuffer = (LPSTR)lpBasePtr;

	// f[^ǂݍ
	bRet = TRUE;
	try
	{
		CopyMemory(&dwSize, lpBuffer, sizeof(DWORD));
		lpBuffer += sizeof(DWORD);

		while(*lpBuffer)
		{
			// Gg
			lpType1 = lstrchr(lpBuffer, '.');
			lpType1++;
			lpType2 = lstrchr(lpType1, '\01');
			lpType2++;
			lstrcpyn(szTemp, lpType1, lpType2 - lpType1);

			// Gg̎ނƂɕ
			if(lstrcmpi(szTemp, "hwnd") == 0)
			{
				// f[^擾
				lpType1 = lstrchr(lpType2, '\r');
				lpType1++;
				lstrcpyn(szTemp, lpType2, lpType1 - lpType2);
				hWnd = (HWND)atoi(szTemp);

				vec.push_back(hWnd);
			}

			// \r\n ܂łPGg
			lpBuffer = lstrchr(lpBuffer, '\n');
			if(lpBuffer)
			{
				lpBuffer++;
			}
		}

		bRet = vec.size() > 0 ? TRUE : FALSE;
	}
	catch(...)
	{
		bRet = FALSE;
	}

	UnmapViewOfFile(lpBasePtr);
	CloseHandle(hFileMap);
	return bRet;
}

/*----------------------------------------------------------------------------
	DirectSSTPSendMessage()
	DirectSSTP bZ[WM
----------------------------------------------------------------------------*/
BOOL DirectSSTPSendMessage(HWND hParentWnd, LPCSTR szData)
{
	COPYDATASTRUCT cds;
	DWORD dwRet;
	vector<HWND> vec;
	vector<HWND>::iterator it;
	string strSendBuffer;

	// ݂`FbN
	/*if(!CheckSakuraMutex())
	{
		MessageBox(hParentWnd, "SSTPT[o[NĂ܂B", "TestSSTP", MB_ICONSTOP);
		return FALSE;
	}*/

	// EBhE擾
	if(!CheckSakuraFileMapping(hParentWnd, vec))
	{
		MessageBox(hParentWnd, "DirectSSTPgpł܂B", "TestSSTP", MB_ICONSTOP);
		return FALSE;
	}

	strSendBuffer = szData;

	// M
	cds.dwData = MY_DIRECTSSTP_PORT;
	cds.cbData = strSendBuffer.size();
	cds.lpData = (LPVOID)strSendBuffer.c_str();
	for(it = vec.begin(); it != vec.end(); it++)
	{
		// WM_COPYDATA ͔ėpȂ̂ŁAHWND_BROADCAST Ă͂܂B
		SendMessageTimeout(*it, WM_COPYDATA, (WPARAM)hParentWnd, (LPARAM)&cds,
			SMTO_ABORTIFHUNG, 1000, &dwRet);
	}

	return TRUE;
}
