/*----------------------------------------------------------------------------

  Light SSTP Client
  Copyright(C) 2001 Koumei Hashimoto, all rights reserved.

  main.cpp

----------------------------------------------------------------------------*/
#include "header.h"
#include "resource.h"
#include "stdio.h"

/*----------------------------------------------------------------------------
	֐錾
----------------------------------------------------------------------------*/
BOOL InitWinsock(VOID);
BOOL CheckNiseHaruna();
BOOL SSTPSendMessage(LPCSTR, INT, LPCSTR, string&);
BOOL DirectSSTPSendMessage(HWND, LPCSTR);

/*----------------------------------------------------------------------------
	DiarogProc()
	_CAOvV[W
----------------------------------------------------------------------------*/
BOOL CALLBACK DialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	CHAR szServer[200];
	CHAR szScriptBuf[4000];
	char *pBuffer;
	HCURSOR hCursor;
	INT nPort;

	string strScript;
	string strStatus;

	COPYDATASTRUCT* lpCDS;

	switch(uMsg)
	{
	case WM_COPYDATA:

		// DirectSSTP Xe[^XR[hM
		lpCDS = (COPYDATASTRUCT*)lParam;

		// ʃobt@
		lstrcpyn(szScriptBuf, (LPCSTR)lpCDS->lpData, lpCDS->cbData);
		strStatus = szScriptBuf;
	
		SetDlgItemText(hWnd, IDC_STATUS, strStatus.c_str());
		return TRUE;

	case WM_INITDIALOG:

		// lݒ
		Edit_SetText(GetDlgItem(hWnd, IDC_SERVER), "127.0.0.1");
		Edit_SetText(GetDlgItem(hWnd, IDC_SCRIPT), "SEND SSTP/1.4\r\nSender: ȈSSTPNCAg\r\nScript: \\h\\s0eXg[B\\u\\s[10]eXgȁB\r\nOption: notranslate\r\n\r\n");
		SetDlgItemInt(hWnd, IDC_SSTPPORT, 9801, FALSE);

		char tmp[128];
		sprintf(tmp,"HWnd: %u",hWnd);
		Edit_SetText(GetDlgItem(hWnd, IDC_HWND),tmp);

		return TRUE;

	case WM_COMMAND:

		switch(GET_WM_COMMAND_ID(wParam, lParam))
		{
		case ID_SEND:
			
			SetDlgItemText(hWnd, IDC_STATUS, "");

			// f[^擾
			{
				HWND hW = GetDlgItem(hWnd, IDC_SCRIPT);
				int size = GetWindowTextLength(hW);
				pBuffer = (char*)malloc(size + 6);

				Edit_GetText(hW, pBuffer, size + 1);
				memcpy(pBuffer + size,"\r\n\r\n",5);
			}

			// Ms
			if(IsDlgButtonChecked(hWnd, IDC_USEDIRECTSSTP) == BST_CHECKED)
			{
				// DirectSSTP
				DirectSSTPSendMessage(hWnd, pBuffer);
			}
			else
			{
				// ʏ SSTP
				nPort = GetDlgItemInt(hWnd, IDC_SSTPPORT, NULL, FALSE);

				Edit_GetText(GetDlgItem(hWnd, IDC_SERVER), szServer, sizeof(szServer));

				// bZ[WM
				hCursor = SetCursor(LoadCursor(NULL, IDC_WAIT));
				SSTPSendMessage(szServer, nPort, pBuffer, strStatus);
				SetCursor(hCursor);

				SetDlgItemText(hWnd, IDC_STATUS, strStatus.c_str());
			}
			free(pBuffer);
			return TRUE;

		case IDOK:
		case IDCANCEL:

			EndDialog(hWnd, IDOK);
			return TRUE;

			break;
		}

	default:
		if ( uMsg > WM_USER ) {
			char tmpTxt[64];
			sprintf(tmpTxt,"%u,%u,%u",uMsg,wParam,lParam);
			Edit_SetText(GetDlgItem(hWnd, IDC_MSG),tmpTxt);
		}
		break;
	}

	return FALSE;
}

/*----------------------------------------------------------------------------
	WinMain()
	CGg|Cg
----------------------------------------------------------------------------*/
INT APIENTRY WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR szCmdLine, INT nShow)
{
	// Winsock 
	InitWinsock();

	// _CAO\
	DialogBox(hInst, MAKEINTRESOURCE(IDD_DIALOG), NULL, DialogProc);

	// Winsock \[X
	WSACleanup();
	return 0;
}
